% read_ot_log.m
%
% Script for parsing and storing OpenTherm data, as logged by Schelte
% Bron's OTGW, with otmonitor-armhf, version 4.2.4.1.
%
% Data fields as used by Eneco toon's boiler interface are implemented,
% others may be added easily.
%
data_root   = './otmonitor/logs/';
file_prefix = 'otlog-';
file_ext    = '.txt';
date_format = '%4d%2d%2d';          % yyyymmdd
date_fmt_l  = 8;
%
% find files
%
D = dir(data_root);
[r,c] = size(D);

name_len = length(file_prefix) + date_fmt_l + length(file_ext);

for cnt = 1:r
    %
    % filter out files with right filename length, prefix and extension.
    %
    if ( length(D(cnt).name) == name_len )

        if ( D(cnt).name(1:length(file_prefix)) == file_prefix )

            if ( D(cnt).name(length(D(cnt).name)-length(file_ext)+1: ...
                             length(D(cnt).name)) == file_ext )

                date_str = D(cnt).name(length(file_prefix)+1 : ...
                                       length(D(cnt).name)- ...
                                       length(file_ext));
               
                %
                % OTmonitor logs only store hh:mm:ss.ssssss timestamps, so
                % get the date offset from the filename.
                %
                
                file_date = sscanf( date_str, date_format, 3 );
                
                unix_time = floor( 86400 * ( datenum(file_date(1), ...
                                                     file_date(2), ...
                                                     file_date(3)) - ...
                                             datenum('01-Jan-1970') ) );
                filename = [data_root, D(cnt).name];
                
                %
                % parse contents and save
                %
                
                cmd = sprintf(['otlog_%s = parse_otmon_log( filename, ' ...
                               'unix_time );'], date_str );
                eval( cmd );
                cmd = sprintf('save %sotlog-%s.mat otlog_%s', data_root, ...
                              date_str, date_str );
                eval( cmd );
                
                %
                % check timestamp of last entry in file
                %
                
             end;
        end;
    end;
end;

